$ verifying='f$verify(0)' !gnu_cc:[000000]gcc.com
$!
$! GNU "CC" Compiler command file for gcc 2.x (also works with 1.x).
$!
$! Invoked from the GCC compile driver via LIB$DO_COMMAND:
$!	P1 = File to compile.
$!	P2 = Options:
$!		P - use C++ compiler
$!		O - use ObjC compiler
$!		V - be verbose during compilation (echo program invocations)
$!		L - save preprocessor output as listing
$!		M - generate/save assembler code (/machine_code qualifier)
$!		* - generate object file
$!	P3 = Name of object file.
$!	P4 = Name of assembler file.
$!	P5 = Name of listing file.
$!
$! cpp_Options: Options for preprocessor, including all defines,undef,include.
$! cc1_Options: Options for compiler.  This should *not* include the following
$!		switches, as they are taken care of in the driver program:
$!			-mdont-save-r2-r5	(PCC-style register saving)
$!			-mpcc-alignment		(PCC-style struct align)
$! gas_Options: All options for assembler.
$!
$! gcc_debugging: controls the behavior of this command procedure:
$!	bit	mask	meaning
$!	 0	 1	 enable DCL verification (echo everything)
$!	 1	 2	 display arguments
$!	 2	 4	 use `/log' when deleting intermediate files
$!	 3	 8	 echo program invocations; same as /verbose=echo
$!
$ if f$type(gcc_debugging).nes."INTEGER"
$ then	gcc_debugging = f$trnlnm("GCC_DEBUGGING") !for debugging this DCL proc
$	if f$type(gcc_debugging).nes."INTEGER" then gcc_debugging = 0
$ endif
$ if (gcc_debugging.and.2).ne.0
$ then	show symbol/Local P%			!list arguments
$	if f$type(cpp_Options).nes."" then show symbol cpp_Options
$	if f$type(cc1_Options).nes."" then show symbol cc1_Options
$	if f$type(gas_Options).nes."" then show symbol gas_Options
$ endif
$ if (gcc_debugging.and.1).ne.0 then set verify !echo further commands
$!
$!  Constants:
$!
$ if GCC_BinDir.eqs."" then GCC_BinDir = "000000"
$ gcc_cpp	= "$gnu_cc:[''GCC_BinDir']gcc-cpp"
$ gcc_cc1	= "$gnu_cc:[''GCC_BinDir']gcc-cc1"
$ gcc_cc1obj	= "$gnu_cc:[''GCC_BinDir']gcc-cc1obj"
$ gcc_cc1plus	= "$gnu_cc:[''GCC_BinDir']gcc-cc1plus"
$!- gcc_collect = "$gnu_cc:[''GCC_BinDir']vms-collect"
$ gcc_as	= "$gnu_cc:[''GCC_BinDir']gcc-as"
$ ECHO		= "write sys$output"
$ DELETE	= "delete/noConfirm/Since=""''f$time()'"""
$ if (gcc_debugging.and.4).ne.0 then DELETE = DELETE + "/Log"
$!
$!  Options:
$!
$ p2_length = f$length(p2)
$ Generate_Obj	= f$locate("*",p2) .lt. p2_length	!make 'p1'.obj
$ Keep_Assmblr	= f$locate("M",p2) .lt. p2_length	!save 'p1'.s
$ Keep_Preproc	= f$locate("L",p2) .lt. p2_length	!save 'p1'.cpp
$ Plus		= f$locate("P",p2) .lt. p2_length	!compile with C++
$ ObjC		= f$locate("O",p2) .lt. p2_length	! " w/ Objective-C
$ Gas_it	= f$locate("S",p2) .lt. p2_length	!assemble as-is
$ Echo_Commands = f$locate("V",p2) .lt. p2_length	!show gcc-*.exe cmds
$ if (gcc_debugging.and.8).ne.0 then Echo_Commands = 1
$!
$ ctrl_Y = 0
$ phase = "ini"
$ On Error     then Goto Error_Abort
$ On Control_Y then Goto CtrlY_Abort
$!
$ Lang = 0 + 1*Plus + 2*ObjC	! C == 0, C++ == 1, Obj-C == 2
$ if Lang.lt.0 .or. Lang.gt.2 then goto Internal_Error
$!
$!	File name processing
$!
$!!   c_def_typ = f$element(Lang," ",".c .cc .m")   !default type for source
$     i_def_typ = f$element(Lang," ",".i .ii .i")   !default type for preproc
$ C_file	= p1
$ I_file	= p5
$ S_file	= p4
$ O_file	= p3
$ Extension	= f$edit(f$parse(C_file,,,"TYPE","SYNTAX_ONLY"),"LOWERCASE")
$ if Extension.eqs.i_def_typ .or. (Extension.eqs.".cpp" .and. .not.Plus)
$ then	I_file = C_file		!already preprocessed
$	Keep_Preproc = 1	!don't delete input file
$	goto do_compile
$ endif
$ if Extension.eqs.".s" .or. Gas_it
$ then	S_file = C_file		!already compiled
$	Keep_Assmblr = 1	!don't delete input file
$	goto do_assembly
$ endif
$!
$!	Pre-process the source file
$!
$do_preproc:
$ phase = "cpp"
$ if Echo_Commands then set verify
$ gcc_cpp 'C_file' 'cpp_Options' -o 'I_file'
$ Status=$status !'f$verify(gcc_debugging)'
$ if Status.ne.1 then goto cpp_cleanup
$!
$!	Compile the preprocessed file
$!
$do_compile:
$ if .not.(Generate_Obj .or. Keep_Assmblr) then goto Done
$ phase = "cc1"
$ cc1 = f$element(Lang," ","gcc_cc1 gcc_cc1plus gcc_cc1obj")
$ if Echo_Commands then set verify
$ 'cc1' 'I_file' 'cc1_Options' -o 'S_file'
$ Status=$status !'f$verify(gcc_debugging)'
$ if Status.ne.1 then goto cc1_cleanup
$ if .not.Keep_Preproc
$ then	p5 = f$search(I_file)
$	if p5.nes."" then DELETE 'p5'
$ endif
$!- if Plus
$!- then  !Append constructor/destructor information to the assembler file
$!-  phase = "collect"
$!-  gcc_collect 'S_file'
$!- endif
$!
$!	Assemble the generated file
$!
$do_assembly:
$ if .not.Generate_Obj then goto Done
$ phase = "gas"
$ if Echo_Commands then set verify
$ gcc_as 'S_file' 'gas_Options' -o 'O_file'
$ Status=$status !'f$verify(gcc_debugging)'
$ if Status.ne.1 then goto gas_cleanup
$ if .not.Keep_Assmblr
$ then	p4 = f$search(S_file)
$	if p4.nes."" then DELETE 'p4'
$ endif
$!
$ goto Done
$
$!
$!	Error handling
$!
$Internal_Error:
$! (this should never happen; fall through to control-Y handler if it does)
$ ECHO "%GCC-F-WHAT???, internal error in gcc.com!"
$!
$CtrlY_Abort: Status=%x002C !'f$verify(gcc_debugging)'
$ on control_Y then continue
$ ctrl_Y = 1
$ goto 'phase'_cleanup
$!
$Error_Abort: Status=$status !'f$verify(gcc_debugging)'
$ goto 'phase'_cleanup
$!
$gas_cleanup:
$ on error then continue
$ p3 = f$search(O_file)
$ if p3.nes.""	!we have a file by the right name, but it might be an old one
$ then	DELETE 'p3'
$	if f$search(p3).eqs.""	!we've deleted it, so it wasn't an old one
$	then	ECHO "%GCC-E-NOOBJECT, object file deleted"
$		Status = Status .or. %x10000000
$		Generate_Obj = 0	!avoid "no object file was produced"
$	endif
$ endif
$ ctrl_Y = 0	!reached gas, so cc1 phase completed
$!-collect_cleanup:
$cc1_cleanup:
$ on error then continue
$ if ctrl_Y .or. .not.Keep_Assmblr
$ then	p4 = f$search(S_file)
$	if p4.nes."" then DELETE 'p4'
$ endif
$ ctrl_Y = 0	!reached cc1, so cpp phase completed
$cpp_cleanup:
$ on error then continue
$ if ctrl_Y .or. .not.Keep_Preproc
$ then	p5 = f$search(I_file)
$	if p5.nes."" then DELETE 'p5'
$ endif
$ ctrl_Y = 0	!reached cpp, so what?
$ini_cleanup:
$ if Generate_Obj
$ then	ECHO "%GCC-E-NOOBJECT, no object file was produced"
$	Status = Status .or. %x10000000
$ endif
$ exit Status + 0*f$verify(verifying)
$!
$!	Normal completion
$!
$Done:
$ if verifying then set verify
