/* <locale.h>
 *
 *	This is subject to change, since VAXCRTL doesn't support locales yet.
 */
#ifndef _LOCALE_H
#define _LOCALE_H
# ifdef __cplusplus
extern "C" {
# endif

#ifndef NULL
#define NULL ((void *)0)
#endif

/*
   VAX C's VAXCDEF.TLB(LOCALE) [not extracted during installation, and
   undocumented] and GEM C's <locate.h> both have -1 (_ALL) thru 4 (_TIME).
   The values for VMS POSIX are different.  Ultrix, SunOS, and NeXT
   also all have different values (from each other as well as from these).
 */
#define LC_ALL		(-1)
#define LC_COLLATE	0
#define LC_CTYPE	1
#define LC_MONETARY	2
#define LC_NUMERIC	3
#define LC_TIME		4

struct lconv {
    char *decimal_point, *thousands_sep, *grouping,
	 *int_curr_symbol, *currency_symbol,
	 *mon_decimal_point, *mon_thousands_sep, *mon_grouping,
	 *positive_sign, *negative_sign;
    char  int_frac_digits, frac_digits,
	  p_cs_precedes, p_sep_by_space,
	  n_cs_precedes, n_sep_by_space,
	  p_sign_posn, n_sign_posn;
#if 0			/* VMS POSIX has these two extra fields */
    char *left_parenthesis, *right_parenthesis;
#endif
};

#ifdef __STDC__

char *setlocale(int,const char *);
struct lconv *localeconv(void);

#else	/*!__STDC__ => -traditional */
char *setlocale();
struct lconv *localeconv();
#endif

# ifdef __cplusplus
}
# endif
#endif	/*_LOCALE_H*/
