/* <processes.h>
 *
 *	Process creation routines, for compatability with VAX C's <processes.h>
 */
#ifndef _PROCESSES_H
#define _PROCESSES_H
# ifdef __cplusplus
extern "C" {
# endif

#ifdef __STDC__

int execl(const char *,...);
int execle(const char *,...);
int execlp(const char *,...);
int execv(const char *,char **);
int execve(const char *,char **,char **);
int execvp(const char *,char **);
int nice(int);				/* (not listed in any VAX C header) */
int pipe(int *,...);			/* two optional args */
int system(const char *);		/* also defined in <stdlib.h> */
int vfork(void);
int wait(int *);			/* int * is correct; not union wait * */

#else	/*!__STDC__ => -traditional */
int execl(), execle(), execlp(), execv(), execve(), execvp();
int nice(), pipe(), system(), vfork(), wait();
#endif	/*?__STDC__*/

# ifdef __cplusplus
}
# endif
#endif	/*_PROCESSES_H*/
